//
//  Struttura dati per rappresentare un Vettore
//

#include <iostream.h>

const LOWER = 1;			// Estremo inferiore per l'operatore []
const UPPER = 3;			// Estremo superiore per l'operatore []
const SIZE = UPPER - LOWER + 1;		// Numero di componenti

class vector 
{
  double c[SIZE];

public:
  vector();
  vector(double *a);

  // Operatori di Somma, Sottrazione e Moltiplicazione;
  friend vector operator+ (const vector& v, const vector& w);
  friend vector operator- (const vector& v, const vector& w);
  friend vector operator- (const vector& v);
  friend vector operator* (double a, const vector& w);
  friend vector operator* (const vector& v, double b);
  friend double operator* (const vector& v, const vector& w);

  // Operatori di Confronto;
  friend int operator== (const vector& v, const vector& w);
  friend int operator!= (const vector& v, const vector& w);

  // Operazioni combinate con Assegnamenti;
  vector& operator+= (const vector& w);
  vector& operator-= (const vector& w);
  vector& operator*= (double b);

  // Operatori di Inserimento ed Estrazione;
  friend istream& operator>> (istream& ci, vector& v);
  friend ostream& operator<< (ostream& co, const vector& v);

  // Altri Operatori;
  double& operator[] (int i);		// Indicizzazione
  operator double() const;		// Conversione di tipo / Norma
};
